var gui = new GUI();

function GUI() {
   var List = IR.GetItem("Main").GetItem("List");
   List.Template = "List_template";
   var Current = 0;
   
   this.ListPush = function (in_beacon_info) {
      var num = List.ItemsCount;
      List.CreateItem(num, 2, {Text: in_beacon_info.Name});
      List.CreateItem(num, 3, {Text: in_beacon_info.MAC});          
   }
   
   this.UpdateCurrent = function () {
      if(Current) {
         var cur_beacon = beaconScanner.Get(Current);
         IR.GetPopup("BeaconInfo").GetItem("beacon_name").Text = cur_beacon.Name;
         IR.GetPopup("BeaconInfo").GetItem("beacon_mac").Text = cur_beacon.MAC;
         IR.GetPopup("BeaconInfo").GetItem("current_rssi").Value = cur_beacon.CurrentRSSI;
         IR.GetPopup("BeaconInfo").GetItem("average_rssi").Value = cur_beacon.AverageRSSI;
         IR.GetPopup("BeaconInfo").GetItem("distance").Value = cur_beacon.Distance;
         IR.GetPopup("BeaconInfo").GetItem("tx_power").Value = cur_beacon.TXPower;
         
         IR.GetPopup("BeaconInfo").GetItem("distance_backing").Visible = !cur_beacon.CalibrationStatus;
         IR.GetPopup("BeaconInfo").GetItem("distance_backing").Enable = !cur_beacon.CalibrationStatus;
         IR.GetPopup("BeaconInfo").GetItem("power_backing").Visible = !cur_beacon.CalibrationStatus;
         IR.GetPopup("BeaconInfo").GetItem("power_backing").Enable = !cur_beacon.CalibrationStatus;
      }
   }
   
   IR.AddListener(IR.EVENT_ITEM_SELECT, List, function(Item, Subitem) {
      Current = beaconScanner.GetByPos(Item).MAC;
      this.UpdateCurrent();
      IR.ShowPopup("BeaconInfo");
   }, this);
   
   IR.AddListener(IR.EVENT_ITEM_RELEASE, IR.GetPopup("BeaconInfo").GetItem("button_calibrate"), function() {
      if(Current) {
         var cur_beacon = beaconScanner.Get(Current);   
         cur_beacon.Calibrate.call(cur_beacon);
         IR.ShowPopup("CalibrationProgress");
      }   
   }, this);
}